import themidibus.*;
import controlP5.*;
import controlP5.*;
import ddf.minim.analysis.*;
import ddf.minim.analysis.FFT;
import ddf.minim.*;
import controlP5.*;


MidiBus myBus;
//MidiBus myBus2;
Minim minim;
BeatDetect beat;
AudioInput in;
FFT fftLog;
FFT fft;
ControlP5 cp5;


int reactLast;
int reactBetween = 10;
float soundIntensity = 0.05;
//to make it play song files

// Setup params
color bgColor = color(220, 100, 200);
color dial = color(244, 66, 66);
int SCREEN_WIDTH;
int SCREEN_HEIGHT;

// Modifiable parameters
float spectrumScale = 10;
float STROKE_MAX = 3;
float STROKE_MIN = 0;
float strokeMultiplier = 100;
float audioThresh = 20;
float[] circles = new float[50];
float DECAY_RATE = 50;
float bgr = 100;
float bgb = 100;
float bgg = 100;
float LFO=0;
float dLFO= 10;
float LFO2=0;
float dLFO2= 6;
float LFO3;
float dLFO3= 11;
PFont f;
float sz = 100;
float x;
float y;
float easing = 0.05;
float succ = 0;
float zucc = 1;
float dv = 1;
int Y_AXIS = 1;
int X_AXIS = 2;
color b1, b2, c1, c2;
float sin = LFO;
float space = 1;
float cc[] = new float[256];
float cc2[] = new float[256];
int addy;
int xes = 0;
float eRadius;
int kyler = 225;
int kyleg = 188;
int kyleb = 41;
void setup()
{
  SCREEN_WIDTH = displayWidth;
  SCREEN_HEIGHT = displayHeight;
  f = createFont("yeysk", 400, true);
  textAlign(CENTER);
  myBus = new MidiBus(this, "Arturia KeyStep 32", 0);
  //myBus2 = new MidiBus(this, "TouchOSC Bridge", 0);
  MidiBus.list();
  size(displayWidth, displayHeight, P3D);
  frameRate(60);
beat = new BeatDetect();
  minim = new Minim(this);
  in = minim.getLineIn(Minim.MONO, 64);
  cp5 = new ControlP5(this);


  fftLog = new FFT( in.bufferSize(), in.sampleRate());
  
  fftLog.logAverages( 22, 3);



  ellipseMode(RADIUS);
  
  cp5.addKnob("dv").setRange(0, 50).setSize((int)40, (int)20).setPosition(400, 0).setFont(createFont("cubic", 8, true));
  cp5.addKnob("STROKE_MAX").setRange(0, 50).setSize((int)40, (int)20).setPosition(50, 0).setFont(createFont("cubic", 8, true));  
  cp5.addKnob("sz").setRange(0, 500).setSize((int)40, (int)20).setPosition(140, 0).setFont(createFont("cubic", 8, true));
  cp5.addKnob("bgr").setRange(0, 255).setSize((int)40, (int)20).setPosition(180, 0).setFont(createFont("cubic", 8, true));
  cp5.addKnob("bgg").setRange(0, 255).setSize((int)40, (int)20).setPosition(220, 0).setFont(createFont("cubic", 8, true));
  cp5.addKnob("bgb").setRange(0, 255).setSize((int)40, (int)20).setPosition(260, 0).setFont(createFont("cubic", 8, true));
  cp5.addKnob("succ").setRange(0, 2).setSize((int)40, (int)20).setPosition(300, 0).setId(10).setFont(createFont("cubic", 8, true));

  fft = new FFT(in.bufferSize(), in.sampleRate());
  reactLast = millis();
 /* b1 = color(bgg+50+(succ*zucc)+LFO3);
  b2 = color(0+(succ*zucc)+50);
  c1 = color(bgr+20+(succ*zucc)+50, bgg+50, bgb+50);
  c2 = color(bgr-25+50, 102+(succ*zucc)+50, bgb+50);*/
  
  b1 = color(bgg+50+(succ*zucc)+LFO3);
  b2 = color(0+(succ*zucc)+50);
  c1 = color(kyler,kyleg, kyleb);
  c2 = color(bgr-25+50, 102+(succ*zucc)+50, bgb+50);

  noFill();
}

void setGradient(int x, int y, float w, float h, color c1, color c2, int axis ) {

  noFill();

  if (axis == Y_AXIS) {  // Top to bottom gradient
    for (int i = y; i <= y+h; i++) {
      float inter = map(i, y, y+h, 0, 1);
      color c = lerpColor(c1, c2, inter);
      stroke(c);
      strokeWeight(1);
      line(x-685, i-10, x+w+30, i-10);
    }
  } else if (axis == X_AXIS) {  // Left to right gradient
  }
}


void textout()
{
  float sound = 0;  
  for (int i=0; i<in.bufferSize()-1; i++) {
    sound += in.left.get(i);
  }
  textFont(f, sz*(1));
  fill((LFO2*1.4+(succ*zucc))+(cc[255]+LFO3), LFO3*(succ*zucc), (LFO2));
  text("Constructure", 0+(succ*zucc+(LFO3*succ)), (SCREEN_HEIGHT/100)+30+(succ*zucc));
}

void draw()
{
  float sound = 0;  
  for (int i=0; i<in.bufferSize()-1; i++) {
    sound += in.left.get(i);
  }
  zucc = random(-100, 100);
  println("xes",xes);
  bgb = (360-(cc[255]*210));
  //bgg -= ((cc[25]*100));
  background(bgr, bgg, bgb);
  fft.forward(in.mix);
  strokeWeight(1);
  //stroke(200,(20*sin(sound)),(20*atan(sound)),26);
  stroke(30+(100*sin(x)), (47+(100*atan(x))), x*20, 26);
  pushMatrix();
  translate(SCREEN_WIDTH/2, SCREEN_HEIGHT/2);
  // Push new audio samples to the FFT
  //fftLog.forward(input.left);
  fftLog.forward(in.mix);
  //textFont(f,sz*(lerp(abs(x+1)/10,1,0.5)));     
  textout();
  setGradient(50, 90, 540, 80, c1, c2, Y_AXIS);
  setGradient(50, 190, 540, 80, c2, c1, X_AXIS);
  // STEP 5 Display Text
  /*for(int k=0;k<300;k++)
   {
   polygon(sound*10,sound*50,(int)(2)+10,20,random(TWO_PI));
   }*/
  //SYCC      SYKA
  
  
  beat.detect(in.mix);
  
  float a = map(xes, 20, 80, 60, 255);
  
  if ( beat.isOnset() ) xes = 100; 
  //ellipse(width/2, height/2, eRadius, eRadius);
  xes *= .20;
  if ( xes < 20 ) xes = 1; 
  
  if ( beat.isOnset() ) succ = 1.68;
  //ellipse(width/2, height/2, eRadius, eRadius);
  succ *= .25;
  if ( xes < 20 )  succ=0;
  
  
  // Loop through frequencies and compute width for ellipse stroke widths, and amplitude for size

  LFO += dLFO; 
  if ((LFO <= -800) || (LFO >= 100)) { // if out of bounds
    dLFO = - dLFO; // swap direction
  }
  LFO2 += dLFO2; 
  if ((LFO2 <= 0) || (LFO2 >= 225)) { // if out of bounds
    dLFO2 = - dLFO2; // swap direction
  }
  LFO3 += dLFO3; 
  if ((LFO3 <= 0) || (LFO3 >= 225)) { // if out of bounds
    dLFO3 = - dLFO3; // swap direction
  }
  space = LFO;
  for (int i = 0; i < 29; i++) {

    // What is the average height in relation to the screen height?
    float amplitude = fftLog.getAvg(i);

    float targetY = amplitude;
    float dy = targetY - y;
    y += dy * easing;




 // if ( beat.isOnset() ) xes = 100;



    // If we hit a threshhold, then set the circle radius to new value
    if (y<audioThresh) {
      circles[i] = (x/dv) *(SCREEN_HEIGHT/2);
    } else { // Otherwise, decay slowly
      circles[i] = max(0, min(SCREEN_HEIGHT, circles[i]-DECAY_RATE));
    }

    // What is the centerpoint of the this frequency band?
    float centerFrequency = fftLog.getAverageCenterFrequency(i);

    // What is the average width of this freqency?
    float averageWidth = fftLog.getAverageBandWidth(i);


    // Get the left and right bounds of the frequency
    float lowFreq = centerFrequency - averageWidth/2;
    float highFreq = centerFrequency + averageWidth/2;

    float targetX = sound;
    float dx = targetX - x;
    x += dx * easing;



    // Convert frequency widths to actual sizes
    int xl = (int)fftLog.freqToIndex(lowFreq);
    int xr = (int)fftLog.freqToIndex(highFreq);
    //fft shit
    float fftBand;
    //translate((width/2)-(xr*100), 100+(xl*500));
    for (int j = 0; j < fft.specSize(); j++) {
      fftBand = fft.getBand(j) * 4;
      // line(j+10, height*-3/5, j+(fftBand), (height*5/6 - (fftBand*100)));
      //line(-j-10, height*-3/5, -j-(fftBand), (height*5/6 - (fftBand*100)));
      //line(j, height*4/5, j, (height*2/3 - (fftBand)));
      //line(-j, height*4/5, -j, (height*2/3 - (fftBand)));
    }

    pushStyle();

    // Calculate the gray value for this circle
    //stroke(xr*(xl*15),xr*10,xl*10,amplitude*255);
    stroke(10*(x+(xes*2)), 0+(xes*6)+(LFO2/10), 100+x*40+(xes*4), y*50);
    strokeWeight(map(y, 10, 1, STROKE_MIN, STROKE_MAX+(xes/10)));
    //x = lerp(x, mouseX, 0.05);
    // y = lerp(y, mouseY, 0.05);
    // Draw an ellipse for this frequency
    ellipse(350+space, 250+(space/3.14), circles[i], circles[i]);
    ellipse(-350-space, 250+(space/3.14), circles[i], circles[i]);
    ellipse(0, -300-(space/1.5), circles[i], circles[i]);
    ellipse(600+space, 100, circles[i], circles[i]);
    ellipse(-600-space, 100, circles[i], circles[i]);
    ellipse(0, 300+(space/1.5), circles[i], circles[i]);
    ellipse(-350-space, -250-(space/3.14), circles[i], circles[i]);
    ellipse(350+space, -250-(space/3.14), circles[i], circles[i]);
    //ellipse(0,0,fft.getBand(50) * 100, fft.getBand(50)*100);

    // triangle(0, 0, -400 ,lerp(circles[i],200,.5), 400,lerp(circles[i],200,.5));
    noFill();
    popStyle();
  }
  popMatrix();
}
void controllerChange(int channel, int number, int value) {
  // Here we print the controller number.
  // The number that gets printed is the number we have to use
  // when accessing the cc[] array. Above we use numbers like
  // 98, 99, 100, 101, 102, 103 and 104. Those numbers are
  // specific to each controller.
  println(number);
  cc[number] = map(value, 0, 127, 0, 1);
}